<?php

namespace Aedes\EveryPay\Api\Data;


interface NonceRepositoryInterface
{
    /**
     * Create or update a nonce.
     *
     * @param \Aedes\EveryPay\Api\Data\NonceInterface $nonce
     * @return \Aedes\EveryPay\Api\Data\NonceInterface
     */
    public function save(\Aedes\EveryPay\Api\Data\NonceInterface $nonce);

    /**
     * Get a list of nonces matching the specified criteria.
     *
     * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
     * @return \Magento\Framework\Api\SearchResultsInterface;
     */
    public function getList(\Magento\Framework\Api\SearchCriteriaInterface $searchCriteria);
}