<?php

namespace Aedes\EveryPay\Block;

class PaymentForm extends \Magento\Framework\View\Element\Template
{
    /**
     * @var \Aedes\EveryPay\Model\Config
     */
    protected $config;

    /**
     * @param \Magento\Framework\View\Element\Template\Context $context
     * @param \Aedes\EveryPay\Model\Config $config
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Aedes\EveryPay\Model\Config $config,
        array $data = []
    ) {
        $this->config = $config;

        parent::__construct($context, $data);
    }

    /**
     * @return \Magento\Framework\View\Element\Template
     */
    protected function _prepareLayout()
    {
        $this->addChild(
            'iframe',
            'Aedes\EveryPay\Block\IFrame',
            ['template' => 'Aedes_EveryPay::iframe.phtml']
        );

        $this->addChild(
            'redirect-form',
            'Aedes\EveryPay\Block\RedirectForm',
            ['template' => 'Aedes_EveryPay::redirect-form.phtml']
        );

        return parent::_prepareLayout();
    }

    /**
     * @return bool
     */
    public function isIFrame()
    {
        return $this->config->getFormType() ===  \Aedes\EveryPay\Model\Adminhtml\Source\FormType::FORM_TYPE_IFRAME;
    }
}