<?php

namespace Aedes\EveryPay\Helper;

class ResponseHandler extends \Magento\Framework\App\Helper\AbstractHelper
{
    /**
     * @var Validator
     */
    protected $validator;

    /**
     * @var ResponseProcessor
     */
    protected $responseProcessor;

    /**
     * @param \Magento\Framework\App\Helper\Context $context
     * @param Validator $validator
     * @param ResponseProcessor $responseProcessor
     */
    public function __construct(
        \Magento\Framework\App\Helper\Context $context,
        Validator $validator,
        ResponseProcessor $responseProcessor
    ) {
        $this->validator = $validator;
        $this->responseProcessor = $responseProcessor;

        parent::__construct($context);
    }

    /**
     * @param string[string|int| $response
     * @return array|bool
     */
    public function handleResponse($response)
    {
        $validationResult = $this->validator->validate($response);

        if ($validationResult === true) {
            $this->responseProcessor->process($response);
        }

        return $validationResult;
    }
}